#include <stdio.h>
#include <string.h>
#include "pdflib.h"
#include "substitute.h"

/*char **spoolstrs=
	("FONT", "TEXT", "BITMAP", "TEXTR", "SIZE", "FACE", "BOLD", "ITALIC", "UNDERLINE", "YES", "NO" );
*/

char *fontname;
int fontpitch=12;
int cursize=8;
int curfont=0;
int fntbold=0;
int fntitalic=0;

// Remove unwanted chars like those ugly CRs written by DOS machines!
char *strwash(char *s)
{
int i;
 for (i=0; i!=strlen(s);i++)
  {
   if (s[i]<32) s[i]=' ';
  }
return(s);  
}

int strsplit(char *s, char *sub[10])
{
 int i=0;
 char *b=s; // Beginning of current selection
 char *e=s; // End of current selection

 memset(sub, 0, sizeof(sub)*10);
 while ((i<10)&&(strlen(b)!=0) && (strchr(b, ' ')>0))
  {
   i++; 
   e=strchr(b,' ');		// Find nearest space from beginning
   if (b[0]!='\"') 
   {
    if (e==NULL)
     {
      if (b!=NULL)
       sub[i]=b; 
     }
    if (e!=NULL) 
    {
     e[0]=0;			// Zero out the current end for copying 
     sub[i-1]=b;
     b=++e;
    }
   } else 
   {
    b=strchr(b,'\"');
    b[0]=0;
    b++;
    e=strrchr(b,'\"');
    e[0]=0;
    sub[i-1]=b;
    b=++e;
   }
  }
return(i);  
}

double myatof(char *s)
{
char *buf=strdup(s);
char *vk=buf;
char *nk=NULL;
int i_vk;
int i_nk=0;
double r=0;

if (strchr(buf,'.')) 
 {
  nk=strchr(buf,'.');
  nk[0]=0;
  nk++;
 }

i_vk=atoi(vk);
if (nk!=NULL)
 i_nk=atoi(nk);

r=i_vk;
if (nk!=NULL)
 r+=((double )i_nk)/(10*strlen(nk));

//printf("myatof('%s')=%f\n",s,r);
free(buf);
return(r);
}

void startpage(PDF *p)
{
int font;

 PDF_begin_page(p, a4_width, a4_height);
 font=PDF_findfont(p, "Courier-Bold", "host", 0);
 PDF_setfont(p, font, 12);
 cursize=8;
 curfont=font;
// PDF_scale(p, 28.3465, 28.3465);
}

void putimg(PDF *p, char *filename, double xpos, double ypos, double x2, double y2)
{
 double scale;
 char *name2=findimg(filename,&scale);
 char *finalname=(char *)malloc(strlen(name2)+7);
 int imagehandle;

 strcpy(finalname, "images/");

 strcat(finalname, name2);

 imagehandle=PDF_open_image_file(p, "tiff", finalname, "", 0);
 if (imagehandle!=-1) 
  {
   PDF_place_image(p, imagehandle, xpos, ypos+4, scale);
   PDF_close_image(p, imagehandle);
  } else
  printf("Warning: Couldn't load image '%s' !\n", finalname);

 free(finalname);
}

int setfnt(PDF *p)
{
 int newfnt;
 char *tmp=(char*) malloc(1024);
 

 strcpy(tmp, fontname);

 if ((fntbold!=0)||(fntitalic!=0)) 
  strcat(tmp, "-");

 if (fntbold>0)
  {
   strcat(tmp, "Bold");
  } 

 if (fntitalic>0)
  {
   strcat(tmp, "Italic");
  }
 newfnt=PDF_findfont(p, tmp, "host", 0);
 if (newfnt!=-1)
  {
   PDF_setfont(p, newfnt, fontpitch);
   curfont=newfnt;
   cursize=fontpitch;
  }
 free(tmp);
}

double atopt(char *s) // Converts an ascii string to an pdf pt 
{
 return(myatof(s)*2.83446712);
}

void puttxt(PDF *p, char *txt, char *posx, char *posy)
{
PDF_show_xy(p, txt, myatof(posx)*2.83446712, a4_height-(myatof(posy)*2.83446712)-cursize);
}

void puttxtr(PDF *p, char *txt, char *posx, char *posy)
{
 PDF_show_xy(p, txt,myatof(posx)*2.83446712- PDF_stringwidth(p, txt, curfont, cursize), a4_height-(myatof(posy)*2.83446712)-cursize);
}

void processline(PDF *p, char *s)
{
char *params[10];
int i;
double f;

for (i=0; i<10; i++) 
 params[i]=NULL;
 
strsplit(strwash(s), params);

if (strcmp(params[0], "FONT")==0)
 {
  if (strcmp(params[1],"FACE")==0)
   {
    strcpy(fontname, params[2]);
   } else
  if (strcmp(params[1],"SIZE")==0)
   {
    if (params[2]!=NULL) fontpitch=atoi(params[2]);
   } else 
  if (strcmp(params[1],"UNDERLINE")==0)
   {
    if (strcmp(params[2],"YES")==0)
     {
      PDF_set_parameter(p, "underline", "true");
     } else 
      PDF_set_parameter(p, "underline", "false");
   } else
  if (strcmp(params[1],"BOLD")==0)
   {
    if (strcmp(params[2],"YES")==0)
      fntbold=1; 
    else
      fntbold=0; 
   } else
  if (strcmp(params[1],"ITALIC")==0)
   {
    if (strcmp(params[2],"YES")==0)
      fntitalic=1; 
    else
      fntitalic=0; 
   } 
  setfnt(p);
 } else
if (strcmp(params[0], "TEXT")==0)
 {
  puttxt(p, params[3], params[1], params[2]);
 } else
if (strcmp(params[0], "TEXTR")==0)
 {
  puttxtr(p, params[3], params[1], params[2]);
 } else
if (strcmp(params[0], "BITMAP")==0)
 {
  putimg(p, params[5],myatof(params[1])*2.83446712, a4_height-myatof(params[4])*2.83446712, myatof(params[3])*2.83446712, a4_height-myatof(params[2])*2.83446712);
 } else
if (strcmp(params[0], "NEWPAGE")==0)
 {
  PDF_end_page(p);
  startpage(p);
 }
}

void parsefile(char *filename, char *outfile)
{
	PDF *p;
	int font;
	int n=0;

	FILE *f;
	char *buf=(char *) malloc(2028);
	
	p=PDF_new();
	if (PDF_open_file(p, outfile)==-1)
	 { 
	  fprintf(stderr, "Error: couldn't open %s for writing.\n",outfile);
	 }
	PDF_set_info(p, "Creator", "spool2pdf");	
	PDF_set_parameter(p, "resourcefile", "pdflib.upr");

	startpage(p);

	f=fopen(filename, "r");
	while (!feof(f))
	 {
	  n++;
	  strcpy(buf,"");

	  fgets(buf, 2047, f);
	  if (strlen(buf)>1)
	   {
//	    printf("n=%d buf='%s'\n",n , buf);
	    processline(p, buf);
	   } 
	 }

	PDF_end_page(p);
	PDF_close(p);	
}

 
int main(int argc, char **argv)
{
 if (argc==3) 
 {
  fontname=(char *)malloc(1024);
  strcpy(fontname,"Arial");
  fontpitch=12;
 
  initsubst();
  parsefile(argv[1],argv[2]);
  
  exit(0);
 } else 
 {
  printf("%s: wrong number of parameters.\n",argv[0]);
  printf("Use syntax:\n");
  printf("%s <infile.txt> <outfile.pdf>\n",argv[0]);
 }
 
}
