#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "substitute.h"
#include "chains/chain.h"

element *imgs;
element *fnts;

int sub_strsplit(char *s, char *sub[10])
{
 int i=0;
 char *b=s; // Beginning of current selection
 char *e=s; // End of current selection

 memset(sub, 0, sizeof(sub)*10);
 while ((i<10)&&(strlen(b)!=0) && ((strchr(b, ' ')>0) || (strchr(b, '\"')>0)))
  {
   i++;
   e=strchr(b,' ');             // Find nearest space from beginning
   if (b[0]!='\"')
   {
    if (e==NULL)
     {
      if (b!=NULL)
       sub[i]=b;
     }
    if (e!=NULL)
    {
     e[0]=0;                    // Zero out the current end for copying
     sub[i-1]=b;
     b=++e;
    }
   } else
   {
    b=strchr(b,'\"');
    b[0]=0;
    b++;
    e=strrchr(b,'\"');
    e[0]=0;
    sub[i-1]=b;
    b=++e;
   } 
  }
return(i);
}

void addfont(char *unixname, char *winname, int bold, int italic)
{
 Tfntsubst fnt;

 strncpy(fnt.winname, winname, sizeof(fnt.winname)-1);
 strncpy(fnt.localname, unixname, sizeof(fnt.localname)-1);
 fnt.bold=bold;
 fnt.italic=italic;

 fnts=addelement(&fnt, sizeof(fnt), fnts);
}

void addimg(char *unixfile, char *scale, char *winfile)
{
 Timgsubst img;

 if (unixfile!=NULL)
 {
  strncpy(img.as400name, winfile, sizeof(img.as400name)-1);
  strncpy(img.localname, unixfile, sizeof(img.localname)-1);
  img.scale=((float)atoi(scale))/100;

  imgs=addelement(&img, sizeof(img), imgs);
 }
}

int readfntsub()
{
 FILE *f;
 char *buf=(char *) malloc(1024);
 char *parts[10];

 f=fopen("fonts.conf","r");
 
 while (!feof(f))
  {
   fgets(buf, 1023, f);
   if (buf[0]!='#')
    {
     if (strlen(buf)>3)
      {
       sub_strsplit(buf, parts);
       addfont(parts[0],parts[3],atoi(parts[1]),atoi(parts[2]));
      }
    }
  }
 
 fclose(f);
}

int readimgsub()
{
 FILE *f;
 char *buf=(char *) malloc(1024);
 char *parts[10];

 f=fopen("images.conf","r");
 
 while (!feof(f))
  {
   fgets(buf, 1023, f);
   if (buf[0]!='#')
    {
     if (strlen(buf)>3)
      {
       sub_strsplit(buf, parts);
       addimg(parts[0],parts[1],parts[2]);
      }
    }
  }
 
 fclose(f);
}

char *findfnt(char *name, int bold, int italic)
{
element *fntchain=head(fnts);
int r=0;

while ((fntchain->next==NULL) || (r==0))
 {
  fntchain=fntchain->next;
//r= ((strcasecmp(((Tfntsubst *)fntchain->cur)->winname, name))==0) && (bold=);
 }
 
//  return(NULL); else
//  return(((Tfntsubst *)fntchain->cur)->localname);
}

int isntwinimg(char *name,Timgsubst *t)
{
int r=1;

if (t!=NULL) 
 {
    r=strcasecmp(name, t->as400name);
 } 

return(r);
}

char *findimg(char *s, double *scale)
{
 element *i=head(imgs)->next;
 char *names=malloc(strlen(s)+2);
 char *name=names;

 strcpy(name, s);
 *scale=1;
 if (name!=NULL)
  {
   if (strchr(name,'\\')!=NULL) 
    {
     name=strrchr(name, '\\');
     name[0]=0x0;
     name++;
    }
   while ((i->next!=NULL) && (isntwinimg(name, i->cur)!=0))
    {
     i=i->next;
    }
  }
 printf("isntwinimg returned %d !\n",isntwinimg(name, i->cur)); 
 if (isntwinimg(name, i->cur)==0)
{
  *scale=((Timgsubst *)(i->cur))->scale;
  free(names);
  return(((Timgsubst *)(i->cur))->localname);   
} else
{
 free(names);
 printf("couldn't find substitution for image '%s%' using it literally.\n",s);
 return(s);   
}
}

void initsubst()
{
 fnts=newchain();
 imgs=newchain();
 readfntsub();
 readimgsub();
}
